import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Patrouillerende ridder.
 */
public class Ridder extends Actor {
    
    private int richting;
    
    private int leeftijd;
    
    public Ridder () {
        this.richting = 0;
        this.leeftijd = 0;
    }
    
    /**
     * Nieuwe X-positie als de ridder verder zou lopen in richting 'richting'
     */
    private int nieuweX () {
        // Opgave: doe dit zonder if's
        if (richting == 0) {
            return getX() + 1;
        } else if (richting == 180) {
            return getX() - 1;
        } else {
            return getX();
        }            
    }
    
    /**
     * Nieuwe Y-positie als de ridder verder zou lopen in richting 'richting'
     */
    private int nieuweY() {
        // Opgave: doe dit zonder if's
        if (richting == 270) {
            return getY() - 1;
        } else if (richting == 90) {
            return getY() + 1;
        } else {
            return getY();
        }                    
    }
    
    /**
     * Kan de ridder in de richting 'richting' verder lopen?
     */
    private boolean isRichtingOK() {
        return getWorldOfType(Zaal.class).isVrij(nieuweX(), nieuweY());
    }
    
    /**
     * De ridder probeert eerst of hij naar links kan draaien (links t.o.v. zijn huidige richting). Lukt dit niet
     * dan probeert hij rechtdoor, rechts en terug, in die volgorde. 
     * Anders gezegd, hij houdt de muur aan zijn linkerkant.
     */
    public void act() {
        // bepaal welke prent
        int index = richting / 90 % 4 * 4 + leeftijd % 4;
        setImage ("ridder-" + index + ".png");
        
        // bepaal nieuwe richting
        richting = (richting + 270) % 360; // opgelet, (richting - 90) % 360 werkt niet!
        while (! isRichtingOK() ){
            // opmerking: deze lus stopt zeker
            richting = (richting + 90)  % 360;
        }
        
        // loop in de opgegeven richting
        setRotation(richting);
        move(1);
        setRotation(0);
        leeftijd ++;          
    }
    
}
