import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Zaal waarin gepatrouilleerd wordt. Houdt ook een kaart bij van hoe de zaal eruit ziet.
 */
public class Zaal extends World {

    private static String[] KAART = {
        "xxxxxxxxxxxxxx",
        "x  x         x",
        "x            x",
        "x      xxx xxx",
        "xxx xxx      x",
        "x     x      x",
        "x     x   x  x",
        "xxxxxxxxxxxx x",
        "x       x  x x",
        "x            x",
        "x  x         x",
        "xxxxx    xxxxx",
        "    xxxxxx    "
    };
    
    
    /**
     * Is de gegeven positie op de kaart vrij?
     */    
    private boolean isVrijRijKolom (int rij, int kol) {
        return rij >= 0 && rij < KAART.length && kol >= 0 && kol <= KAART[0].length()
           && KAART[rij].charAt(kol) == ' ';
    }
    
    /**
     * Is de gegeven positie op de wereld vrij? 
     */
    public boolean isVrij (int x, int y) {
         return 
            isVrijRijKolom ((y-4)/4, (x-2)/4) &&
            isVrijRijKolom ((y-4)/4, (x+1)/4) &&
            isVrijRijKolom ((y-1)/4, (x-2)/4) &&
            isVrijRijKolom ((y-1)/4, (x+1)/4) ;
    }
    
    /**
     * Creëer de zaal en plaats de ridder op de startpositie
     */
    public Zaal() {    
       super(57, 57, 8);
       
       Greenfoot.setSpeed(32);
      
       addObject (new Ridder(), 6, 8);
       addObject (new Bovenkant(), 28, 28); // mooi in het midden
       
       setPaintOrder (Bovenkant.class, Ridder.class);
    }
}
